/* SPDX-License-Identifier: LGPL-2.1-or-later */
/*
 * Copyright (C) 2020, Google Inc.
 *
 * vimc_ipa_interface.h - Image Processing Algorithm interface for vimc
 *
 * This file is auto-generated. Do not edit.
 */

#ifndef __LIBCAMERA_IPA_INTERFACE_VIMC_GENERATED_H__
#define __LIBCAMERA_IPA_INTERFACE_VIMC_GENERATED_H__

#include <libcamera/ipa/core_ipa_interface.h>
#include <libcamera/ipa/ipa_interface.h>




namespace libcamera {

namespace ipa {

namespace vimc {



const std::string VimcIPAFIFOPath = "/tmp/libcamera_ipa_vimc_fifo";


enum class _VimcCmd {
	Exit = 0,
	Init = 1,
	Start = 2,
	Stop = 3,
};

enum class _VimcEventCmd {
	DummyEvent = 1,
};


enum IPAOperationCode {
	IPAOperationNone = 0,
	IPAOperationInit = 1,
	IPAOperationStart = 2,
	IPAOperationStop = 3,
};

class IPAVimcInterface : public IPAInterface
{
public:

	virtual int32_t init(
		const IPASettings &settings) = 0;

	virtual int32_t start() = 0;

	virtual void stop() = 0;

	Signal<uint32_t> dummyEvent;
};

} /* namespace vimc */

} /* namespace ipa */

} /* namespace libcamera */

#endif /* __LIBCAMERA_IPA_INTERFACE_VIMC_GENERATED_H__ */